class Assembler(object):
    def __init__(self, variablenzustand):
        self.programm = []
        self.variablenzustand = variablenzustand

##    def initVariablen(self):
##        self.variablen = {}

    def getProgramm(self):
        return self.programm

    def setQuelltext(self, quelltext):
        self.quelltext = quelltext

    def opaddr(self, b):
        """
        zerlegt eine Befehlszeile b in Opcode op und Adresse addr
        """
        op = b[:3]
        if op in ['inc', 'dec', 'jmp', 'tst']:
            i = b.find(' ', 0, len(b))
            addr = b[i+1:len(b)]
        elif op == 'hlt':
            addr = ''
        #print(op, addr)
        return (op, addr)           # Befehlsbestandteile als Tupel 

    def analyse(self, R):
        """
        erzeugt aus einem Quelltext Q das Programm und die Daten (als Listen)
        """
        # Programm und Daten werden als Listen angelegt
        P = []
        D = []
        for line in R:
            if line != '':
                if line[0] == '[':           # Datenzeile
                    i = line.find('=', 0, len(line))
                    var = line[1:i].rstrip()
                    h = line[i+1:].rstrip().lstrip()
                    wert = int(h[:len(h)-1])
                    D = D + [[var, wert]]
                elif line[0] == '#':         # Kommentarzeile
                    pass
                else:
                    P = P + [self.opaddr(line)]   # Befehlszeile
        return (P, D)

    def parse(self, quelltext):
        R = quelltext.split('\n')
        R = R[:len(R)-1]
        try:
            (P, D) = self.analyse(R)
            self.variablenzustand.setVariablenzustand(D)
            self.programm = P
        except:
            pass
        

    def erzeugeBonsaiCode(self):
        self.bonsai_code = []
        laengeProgramm = len(self.programm)
        z = 0
        for anw in self.programm:
            if anw[0] == 'inc':
                var = anw[1]
                var_reg_nr = self.variablenzustand.getIndex(var)
                anwBonsai = ('inc', var_reg_nr)
            elif anw[0] == 'dec':
                var = anw[1]
                var_reg_nr = self.variablenzustand.getIndex(var)
                anwBonsai = ('dec', var_reg_nr)
            elif anw[0] == 'tst':
                var = anw[1]
                var_reg_nr = self.variablenzustand.getIndex(var)
                anwBonsai = ('tst', var_reg_nr)
            elif anw[0] == 'jmp':
                relAddr = eval(anw[1])
                absAddr = z + relAddr
                anwBonsai = ('jmp', absAddr)
            elif anw[0] == 'hlt':
                anwBonsai = ('hlt', None)
            self.bonsai_code = self.bonsai_code + [anwBonsai]
            z = z + 1
        for eintrag in self.variablenzustand.variablen:
            self.bonsai_code = self.bonsai_code + [(eintrag[0], 0)]
        
    def erzeugeBonsaiText(self):
        self.bonsai_text = ''
        laengeProgramm = len(self.programm)
        z = 0
        while z < laengeProgramm:
            if self.bonsai_code[z][0] == 'hlt':
                self.bonsai_text = self.bonsai_text + str(z) + ': ' + \
                                   self.bonsai_code[z][0] + '\n'
            else:
                self.bonsai_text = self.bonsai_text + str(z) + ': ' + \
                                   self.bonsai_code[z][0] + ' ' + str(self.bonsai_code[z][1]) + '\n'
            z = z + 1
        for v in self.variablenzustand.variablen:
            self.bonsai_text = self.bonsai_text + '#0' + '\n'

    def getBonsaiText(self):
        return self.bonsai_text
